
%option noyywrap

%{
#include <string>
#include <deque>
using namespace std;
#include "config_parser.h"

/*#define YY_USER_ACTION fprintf(stderr, "lex: \"%s\"\n", yytext);*/
%}

%x PATS COMMAND

WS [:space:]*

%%
<*>#                            {   register int c; 
                                    while( (c = yyinput()) != '\n' && c != EOF);    
                                }

\[                              {   BEGIN(PATS); 
                                    return '[';
                                }

:                               {   BEGIN(COMMAND); 
                                    return ':';
                                }

<PATS>]                         {
                                    BEGIN(INITIAL); 
                                    return ']';
                                }

<PATS>\/[^\/]*\/                {   yytext[strlen(yytext)-1] = 0; 
                                    yylval.pat_t = yytext+1; 
                                    return PAT;
                                }

<PATS>,                         return ',';

<COMMAND>;                      {   BEGIN(INITIAL); 
                                    return ';';
                                }

<COMMAND>[^;[:space:]]*         {   yylval.arg_t = yytext; 
                                    return ARG;
                                }

<COMMAND>"\""([^"]|\\\")*"\""   {   yytext[strlen(yytext)-1] = 0; 
                                    yylval.arg_t = yytext+1; 
                                    return ARG; 
                                }

<*>([:space:]|"\n")*                   /* otherwise flex prints out the whitespace. */

%%
