
%{
    #include <stdio.h>
    #include <assert.h>
    #include <deque>
    #include <string>
    #include <FlexLexer.h>
    #include "service_responder.hh"

    using namespace std;

    #define YYERROR_VERBOSE
    #undef __GNUC_MINOR__

    int yylex();
    void yyerror(char* text) {
        printf("\nservice_responder: parse error: %s\n", text);
        exit(-3);
    }
%}

%union {
    char* arg_t;
    char* pat_t;
    char* c_str;
    deque<string> *args_t;
}
%token  <arg_t>  ARG
%token  <pat_t>  PAT
%type   <args_t> args
%type   <pat_t>  pattern

%%

configfile: | configfile expression
;

expression: '[' pattern ',' pattern ',' pattern ',' pattern ']' ':' args ';'
{
    assert($11 != 0);
    deque<string>& args = *$11;
/*
    printf("making query [ types=\"%s\", title=\"%s\", descr=\"%s\", url=\"%s\" ].\n" $2, $4, $6, $8);
    printf("command has %d args. they are:\n", args.size());
    for(deque<string>::const_iterator i = args.begin(); i != args.end(); i++) {
        printf("   %s\n", (*i).c_str());
    }
*/
    assert(serviceDir != 0);
    serviceDir->query($2, $4, $6, $8, new Responder(args));
}
;

pattern: PAT        { $$ = strdup($1); }
;

args:               { $$ = new deque<string>; }
    | args ARG      { assert($$ != 0); $$->push_back($2); }
;

